#ifndef _VORBIS_H_
#define _VORBIS_H_

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <vorbis/vorbisenc.h>
#include <shout/shout.h>

class VorbisEncode {
 public:
  VorbisEncode();
  ogg_stream_state os; /* take physical pages, weld into a logical
			  stream of packets */
  ogg_page         og; /* one Ogg bitstream page.  Vorbis packets are inside */
  ogg_packet       op; /* one raw packet of data for decode */
  vorbis_info      vi; /* struct that stores all the static vorbis bitstream
			  settings */
  vorbis_comment   vc; /* struct that stores all the user comments */
  vorbis_dsp_state vd; /* central working state for the packet->PCM decoder */
  vorbis_block     vb; /* local working space for packet->PCM decode */
  int eos;
  FILE *of;
  shout_conn_t conn;

  void ShoutInit( char *ip, 
		  int port, 
		  char * pass, 
		  char *mount);
  void SetupEncode( unsigned int channels,
		    unsigned int bitrate,
		    unsigned int samplerate,
		    FILE *file,
		    const char *filename);
  int Connect();
  void Encode(char *readbuffer, long bytes, int channels);
  void CleanUp();

};
#endif
